// Cyphesis Online RPG Server and AI Engine
// Copyright (C) 2011 Alistair Riddoch
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software Foundation,
// Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

// $Id: d84909a5e29e66d94e9291d05d52150f083f396c $

#ifdef NDEBUG
#undef NDEBUG
#endif
#ifndef DEBUG
#define DEBUG
#endif

#include "common/atlas_helpers.h"

#include <Atlas/Message/Element.h>

#include <cassert>

int main()
{
    {
        std::string package, clss;

        Atlas::Message::MapType script;

        int ret = GetScriptDetails(script, "name", "context", package, clss);

        assert(ret == -1);
    }

    {
        std::string package, clss;

        Atlas::Message::MapType script;
        script["name"] = 1;

        int ret = GetScriptDetails(script, "name", "context", package, clss);

        assert(ret == -1);
    }

    {
        std::string package, clss;

        Atlas::Message::MapType script;
        script["name"] = "foo";

        int ret = GetScriptDetails(script, "name", "context", package, clss);

        assert(ret == -1);
    }

    {
        std::string package, clss;

        Atlas::Message::MapType script;
        script["name"] = "foo";
        script["language"] = 1;

        int ret = GetScriptDetails(script, "name", "context", package, clss);

        assert(ret == -1);
    }

    {
        std::string package, clss;

        Atlas::Message::MapType script;
        script["name"] = "foo";
        script["language"] = "csharp";

        int ret = GetScriptDetails(script, "name", "context", package, clss);

        assert(ret == -1);
    }

    {
        std::string package, clss;

        Atlas::Message::MapType script;
        script["name"] = "foo";
        script["language"] = "python";

        int ret = GetScriptDetails(script, "name", "context", package, clss);

        assert(ret == -1);
    }

    {
        std::string package, clss;

        Atlas::Message::MapType script;
        script["name"] = "foo.bar";
        script["language"] = "python";

        int ret = GetScriptDetails(script, "name", "context", package, clss);

        assert(ret == 0);

        assert(package == "foo");
        assert(clss == "bar");

    }

    {
        std::string package, clss;

        Atlas::Message::MapType script;
        script["name"] = "mim.foo.bar";
        script["language"] = "python";

        int ret = GetScriptDetails(script, "name", "context", package, clss);

        assert(ret == 0);

        assert(package == "mim.foo");
        assert(clss == "bar");

    }

    return 0;
}

// stubs

#include "common/log.h"

void log(LogLevel lvl, const std::string & msg)
{
}
